<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>The Game</title>
    <link rel="shortcut icon" href="https://www.thegame-france.com/favicon.ico" type="image/x-icon">
</head>
<body>
<h3>
    <img src="https://www.thegame-france.com/images/logo.svg" alt="The Game, #1 Escape Game à Paris" height="50px" width="50px">
    The Game,
    test technique
</h3>
<div>
    <a href="./index.html" download="thegame-testtechnique-exercice1-ngo.html">Download code</a>
</div>
<div>
    <a href="https://www.linkedin.com/in/t3i" target="_blank">https://www.linkedin.com/in/t3i</a>
</div>
<div>
    <a href="https://gitlab.com/t3i.public/thegame" target="_blank">https://gitlab.com/t3i.public/thegame</a>
</div>
<div>
    <a href="/thegame/test" target="_blank">test unitaire</a>
</div>

<div>

    <pre>
        <div>
            <button onClick="window.location.reload();">Refresh</button>
        </div>
        inspect the console to show logs detail.
<code>
    <div style="display: flex">
        <div>
            gamemasters
            <div id="gamemasters"></div>
        </div>
        <div>
            sessions
            <div id="sessions"></div>
        </div>
        <div>
            attribution
            <div id="attribution"></div>
        </div>
        <div>
            sorted attribution
            <div id="sortedAttribution"></div>
        </div>
    </div>
</code>
</pre>
</div>
</body>
</html>

<script>

    const GAMEMASTERS = [
        { id: 1, name: 'John', trained_rooms: [2, 3] },
        { id: 2, name: 'Alice', trained_rooms: [4, 10] },
        { id: 3, name: 'David', trained_rooms: [5] },
        { id: 4, name: 'Emily', trained_rooms: [8, 6, 2, 7] },
        { id: 5, name: 'Michael', trained_rooms: [9, 1, 4, 3, 11, 8, 6, 12] },
        { id: 6, name: 'Sophia', trained_rooms: [7, 10] },
        { id: 7, name: 'Daniel', trained_rooms: [8] },
        { id: 8, name: 'Olivia', trained_rooms: [3, 9] },
        { id: 9, name: 'Matthew', trained_rooms: [2, 6, 1, 7, 3, 4] },
        { id: 10, name: 'Emma', trained_rooms: [5, 4] },
        { id: 11, name: 'James', trained_rooms: [11] },
        { id: 12, name: 'Isabella', trained_rooms: [7, 4, 12] },
        { id: 13, name: 'William', trained_rooms: [11] },
        { id: 14, name: 'Ava', trained_rooms: [9] },
        { id: 15, name: 'Benjamin', trained_rooms: [8, 4] },
        { id: 16, name: 'Mia', trained_rooms: [1, 3, 7, 5, 8] },
        { id: 17, name: 'Ethan', trained_rooms: [4, 2] },
        { id: 18, name: 'Charlotte', trained_rooms: [10] },
        { id: 19, name: 'Alexandre', trained_rooms: [9, 2, 8] },
        { id: 20, name: 'Harper', trained_rooms: [1, 12] }
    ];

    const ROOMS = [
        { id: 1, name: "Le Braquage à la francaise" },
        { id: 2, name: "Le Braquage de casino" },
        { id: 3, name: "L'Enlèvement" },
        { id: 4, name: "Le Métro" },
        { id: 5, name: "Les Catacombes" },
        { id: 6, name: "Assassin's Creed" },
        { id: 7, name: "L'Avion" },
        { id: 8, name: "La Mission spatiale" },
        { id: 9, name: "Le Tremblement de terre" },
        { id: 10, name: "Le Cinéma hanté" },
        { id: 11, name: "Le Farwest" },
        { id: 12, name: "Mission secrète" }
    ];

    // Tirage aléatoire des gamemasters
    const random_gamemaster_array = size => GAMEMASTERS.sort(() => Math.random() - 0.5).slice(0, size)

    const attribution = (gamemasters, sessions) => {

        // order the game master by nb rooms they are trained
        gamemasters.sort((a, b) => a.trained_rooms.length - b.trained_rooms.length);


        // get rooms envolve
        const rooms = sessions.map((session) => session.room.id);

        // add gamemaster to session
        gamemasters.forEach(
            (master) => master.trained_rooms.forEach(
                (masterRoomId) => {
                    if (!rooms.includes(masterRoomId)) {
                        return;
                    }
                    (sessions.find((session) => session.room.id === masterRoomId).room.gamemasters ||= []).push(master);
                }
            ));

        // check if there are room without gamemaster
        const emptyRoom = sessions.find((session) => !session.room.gamemasters);
        if (emptyRoom) {
            console.log('empty room', emptyRoom);
            return 'no solution / empty room';
        }

        // order session by nb of gamemaster.
        sessions.sort((a, b) => a.room.gamemasters.length - b.room.gamemasters.length);

        let selectionId = [];
        let indexes = [];
        let minIndex = 0;
        let t = 0;
        while(selectionId.length < sessions.length) {

            console.log('');
            console.log('t', t);
            console.log('size', selectionId.length);
            console.log('minIndex', minIndex);

            const room = sessions[selectionId.length].room;
            const index = room.gamemasters.findIndex(
                (gamemaster, i) =>
                    !selectionId.includes(gamemaster.id)
                    && minIndex <= i
            );

            console.log('index', index);
            const gamemasterId = room.gamemasters[index]?.id;

            if (gamemasterId) {
                selectionId.push(gamemasterId);
                indexes.push(index);
                minIndex = 0;
            } else {

                if (selectionId.length === 1) {
                    console.log('no solution', selectionId);
                    return 'no solution';
                }

                console.log('change branch');
                selectionId.pop();
                indexes.pop();
                minIndex = indexes.slice(-1)[0] + 1;
                indexes[indexes.length - 1] = minIndex;
            }

            if (3000 < t++) {
                console.log('time out');
                console.log('selection', selectionId);
                return 'time out';
            }

        }

        console.log('final selection', selectionId);
        // console.log('indexes', indexes);
        const solution = sessions.map((session, i) => ({roomId: session.room.id, masterId:selectionId[i]}));
        // solution.sort((a, b) => a.roomId - b.roomId);
        return solution;
    }

    const main = () => {
        const gamemasters = random_gamemaster_array(ROOMS.length)
        const sessions = ROOMS.map(room => {return {room: room}})
        const rooms = ROOMS.slice()

        console.log('gamemasters', gamemasters);
        console.log('sessions', sessions);
        // console.log('rooms', rooms);

        const solution = attribution(gamemasters, sessions);

        document.querySelector('#gamemasters').innerHTML = JSON.stringify(gamemasters, null, 2);
        document.querySelector('#sessions').innerHTML = JSON.stringify(sessions, null, 2);
        document.querySelector('#attribution').innerHTML = JSON.stringify(solution || 'no solution', null, 2);
        Array.isArray(solution)  && solution?.sort((a, b) => a.roomId - b.roomId);
        document.querySelector('#sortedAttribution').innerHTML = JSON.stringify(solution || 'no solution', null, 2);

    }

    main();

</script>